Index: trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/TaskCooccurrenceRuleTest.java
===================================================================
--- trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/TaskCooccurrenceRuleTest.java	(revision 1493)
+++ trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/TaskCooccurrenceRuleTest.java	(revision 1918)
@@ -15,15 +15,11 @@
 package de.ugoe.cs.autoquest.usability;
 
-import static de.ugoe.cs.autoquest.usability.UsabilityDefectDescription.COOCCURENCE_PRECED;
-import static de.ugoe.cs.autoquest.usability.UsabilityDefectDescription.COOCCURENCE_SUCCEED;
-import static de.ugoe.cs.autoquest.usability.UsabilityDefectSeverity.HIGH;
-import static de.ugoe.cs.autoquest.usability.UsabilityDefectSeverity.INFO;
-import static de.ugoe.cs.autoquest.usability.UsabilityDefectSeverity.LOW;
-import static de.ugoe.cs.autoquest.usability.UsabilityDefectSeverity.MEDIUM;
+import static de.ugoe.cs.autoquest.usability.UsabilitySmellDescription.COOCCURENCE_PRECED;
+import static de.ugoe.cs.autoquest.usability.UsabilitySmellDescription.COOCCURENCE_SUCCEED;
 
 import org.junit.Before;
 import org.junit.Test;
 
-import de.ugoe.cs.autoquest.usability.UsabilityDefect;
+import de.ugoe.cs.autoquest.usability.UsabilitySmell;
 
 /**
@@ -37,5 +33,5 @@
     @Before
     public void setUp() {
-        UsabilityDefectSeverity.defaultCoverageQuantile = 0;
+        //UsabilitySmellIntensity.defaultCoverageQuantile = 0;
     }
 
@@ -54,8 +50,8 @@
             "}";
         
-        // no defect expected, as interactions do not form tasks
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[] {  };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        // no smell expected, as interactions do not form tasks
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[] {  };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -77,8 +73,8 @@
             "}";
         
-        // no defect expected, as interactions do not form tasks
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[] { };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        // no smell expected, as interactions do not form tasks
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[] { };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -100,9 +96,11 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -128,9 +126,11 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -155,15 +155,23 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -193,11 +201,15 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(LOW, COOCCURENCE_PRECED),
-              new UsabilityDefect(INFO, COOCCURENCE_PRECED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*LOW*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*INFO*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -227,11 +239,15 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(LOW, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(INFO, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*LOW*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*INFO*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -265,11 +281,15 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-           { new UsabilityDefect(LOW, COOCCURENCE_PRECED),
-             new UsabilityDefect(LOW, COOCCURENCE_PRECED),
-             new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-             new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+           { new UsabilitySmell(/*LOW*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+             new UsabilitySmell(/*LOW*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+             new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+             new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -303,11 +323,15 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-           { new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-             new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-             new UsabilityDefect(LOW, COOCCURENCE_SUCCEED),
-             new UsabilityDefect(LOW, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+           { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+             new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+             new UsabilitySmell(/*LOW*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+             new UsabilitySmell(/*LOW*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -341,10 +365,13 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(MEDIUM, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*MEDIUM*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -378,10 +405,13 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(MEDIUM, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*MEDIUM*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -431,10 +461,13 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(MEDIUM, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED),
-              new UsabilityDefect(HIGH, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*MEDIUM*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -484,10 +517,13 @@
             "}";
         
-        UsabilityDefect[] expectedDefects = new UsabilityDefect[]
-            { new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(HIGH, COOCCURENCE_PRECED),
-              new UsabilityDefect(MEDIUM, COOCCURENCE_SUCCEED) };
-
-        assertUsabilityEvaluationResult(expectedDefects, rule.evaluate(createTaskModel(spec)));
+        UsabilitySmell[] expectedSmells = new UsabilitySmell[]
+            { new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*HIGH*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_PRECED),
+              new UsabilitySmell(/*MEDIUM*/ UsabilitySmellIntensity.getIntensity(0),
+                                  COOCCURENCE_SUCCEED) };
+
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
